import { DisableDataSettings } from "./index";
export declare abstract class Base {
    private apiKey;
    protected baseUrl: string;
    protected gameId: string;
    protected sessionID: string | null;
    protected sessionExpiry: any;
    protected piiTracking: boolean;
    protected enabled: boolean;
    protected appDetails: any;
    protected userDetails: any;
    protected anonId: string;
    constructor(apiKey: string, gameId: string, piiTracking?: boolean);
    getUserDetails(): any;
    setUserDetails(details: {
        user_id: string;
        email?: string | undefined;
        wallet_id?: string | undefined;
        [key: string]: any;
    }, createNewAnon?: boolean): any;
    getAppDetails(): any;
    setAppDetails(details: {
        platform_id?: string | undefined;
        client_app_version?: string | undefined;
        server_app_version?: string | undefined;
        store_id?: string | undefined;
        source_id?: string | undefined;
        [key: string]: any;
    }): any;
    populateDefaultValues(type: string, values: any): any;
    getPIITracking(): boolean;
    setPIITracking(piiTracking: boolean): Promise<any> | undefined;
    isEnabled(): boolean;
    setEnabled(enabled: boolean): void;
    getPlayerId(): string;
    setPlayerId(playerId: string): void;
    setDataSettings(settings: DisableDataSettings): void;
    createUAEvent(events: {
        event_type: string;
        event: Object;
    }[]): Promise<{
        message: string;
    }>;
    protected generateAnonId(bypassStored?: boolean): any;
    protected getTemplateEvent(event_type: string, event_sub_type?: string): {
        created_at: string;
        game_id: string;
        event_type: string;
        event: {
            user_id: any;
            session_id: string | null;
            event_sub_type: string | null;
        };
    };
    protected appendHelikaData(): any;
    protected appendPIIData(helika_data: any): any;
    protected appendReferralData(helika_data: any): any;
    protected getUrlParam(paramName: string): string | null;
    protected getAllUrlParams(): {
        key: string;
        value: string;
    }[];
    protected refreshUtms(): any;
    protected refreshLinkId(): string | null;
    protected getRequest<T>(endpoint: string, options?: any): Promise<T>;
    protected postRequest<T>(endpoint: string, options?: any): Promise<any>;
    protected sessionCreate<T>(params?: any): Promise<any>;
    protected endSession<T>(params?: any): Promise<any>;
    protected processEventSentError(e: any): void;
    protected addHours(date: Date, hours: number): string;
    protected addMinutes(date: Date, minutes: number): string;
    protected extendSession(): void;
}
